package tech.powerjob.work.util;


import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.X509Certificate;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ClassName ApiUtils
 * @Author gfq
 * @Date 2020/12/03
 * @Version 1.0
 **/
@Component
@Slf4j
public class ApiUtils {


    @Value("${gettoken}")
    private String gettoken;

    @Value("${client_secret}")
    private String client_secret;

    @Value("${client_id}")
    private String client_id;


    /**
     * @methodName:
     * @description: TODO  调用该类直接跳过ssl证书
     * @author: sbj
     * @createTime: 2022/7/17 13:44
     * @parames:
     * @return:
     */
    static {
        try {
            trustAllHttpsCertificates();
            HttpsURLConnection.setDefaultHostnameVerifier
                    (
                            (urlHostName, session) -> true
                    );
        } catch (Exception e) {
        }
    }

    private static void trustAllHttpsCertificates()
            throws NoSuchAlgorithmException, KeyManagementException {
        TrustManager[] trustAllCerts = new TrustManager[1];
        trustAllCerts[0] = (TrustManager) new TrustAllManager();
        SSLContext sc = SSLContext.getInstance("SSL");
        sc.init(null, trustAllCerts, null);
        HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
    }

    private static class TrustAllManager implements X509TrustManager {
        @Override
        public X509Certificate[] getAcceptedIssuers() {
            return null;
        }
        @Override
        public void checkServerTrusted(X509Certificate[] certs, String authType) {
        }
        @Override
        public void checkClientTrusted(X509Certificate[] certs, String authType) {
        }
    }


    /**
     * 获取应急局数据token
     * @return
     */
    public String getToken(){
        Map<String, String> headers = new HashMap();
        headers.put("client_secret", client_secret);
        headers.put("client_id", client_id);
        String url = gettoken;  //资源url地址
        String token = get(url,headers);
        JSONObject tokens = JSONObject.parseObject(token);
        token = tokens.getString("access_token");
        return token;
    }

    public static String post(String url, Map<String, String> headers, String json) {
        String result = null;
        HttpURLConnection connection = null;
        try {
            URL get = new URL(url);
            connection = (HttpURLConnection) get
                    .openConnection();
            //需要输出
            connection.setDoOutput(true);
            //需要输入
            connection.setDoInput(true);
            //不允许缓存
            connection.setUseCaches(false);
            connection.setConnectTimeout(60000);
            connection.setReadTimeout(60000);
            connection.setRequestMethod("POST");
            for (Map.Entry<String, String> entry : headers.entrySet()) {
                connection.setRequestProperty(entry.getKey(), entry.getValue());
            }

            connection.setRequestProperty("Content-Type", "application/json");
            connection.connect();
            OutputStream dos = connection.getOutputStream();
            dos.write(json.getBytes());

            dos.flush();
            dos.close();
            InputStream ins = connection.getInputStream();

            BufferedReader reader = new BufferedReader(new InputStreamReader(ins, "utf-8"));
            StringBuffer buffer = new StringBuffer();

            String line = null;
            while ((line = reader.readLine()) != null) {
                buffer.append(line);
                buffer.append("\r\n");
            }
            return buffer.toString();

        } catch (Exception e) {
            e.printStackTrace();
            return result;
        }
    }

    private static String get(String url, Map<String, String> headers) {
        String result = null;
        HttpURLConnection connection = null;
        try {
            URL get = new URL(url);
            connection = (HttpURLConnection) get
                    .openConnection();
            //需要输出
            connection.setDoOutput(true);
            //需要输入
            connection.setDoInput(true);
            //不允许缓存
            connection.setUseCaches(false);
            connection.setConnectTimeout(60000);
            connection.setReadTimeout(60000);
            connection.setRequestMethod("GET");
            for (Map.Entry<String, String> entry : headers.entrySet()) {
                connection.setRequestProperty(entry.getKey(), entry.getValue());
            }

            connection.connect();
            InputStream ins = connection.getInputStream();

            BufferedReader reader = new BufferedReader(new InputStreamReader(ins, "utf-8"));
            StringBuffer buffer = new StringBuffer();

            String line = null;
            while ((line = reader.readLine()) != null) {
                buffer.append(line);
                buffer.append("\r\n");
            }
            return buffer.toString();

        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }

    public static String sendGet(String url, String param){
        String result = "";
        BufferedReader in = null;
        try {
            String urlNameString = url + "?" + param.replaceAll(" ","%20");
//            String urlNameString = url + "?" + param;
            URL realUrl = new URL(urlNameString);
            // 打开和URL之间的连接
            URLConnection connection = realUrl.openConnection();
            // 设置通用的请求属性
            connection.setRequestProperty("accept", "*/*");
            connection.setRequestProperty("connection", "Keep-Alive");
            connection.setRequestProperty("user-agent",
                    "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
            // 建立实际的连接
            connection.connect();
            // 获取所有响应头字段
            Map<String, List<String>> map = connection.getHeaderFields();
            // 遍历所有的响应头字段
            for (String key : map.keySet()) {
                System.out.println(key + "--->" + map.get(key));
            }
            // 定义 BufferedReader输入流来读取URL的响应
            in = new BufferedReader(new InputStreamReader(
                    connection.getInputStream(),"utf-8"));
            String line;
            while ((line = in.readLine()) != null) {
                result += line;
            }
        }catch (Exception err){
            err.printStackTrace();
            log.info(err.getMessage());
        }
        // 使用finally块来关闭输入流
        finally {
            try {
                if (in != null) {
                    in.close();
                }
            } catch (Exception e2) {
                e2.printStackTrace();
            }
        }
        return result;
    }

    private String getCurrentDateTime(){
        SimpleDateFormat simpleFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return simpleFormat.format(new Date());
    }
}
